provider "helm" {
  kubernetes {
    config_path    = "~/.kube/config"
    config_context = "{{ kubeinstaller.context }}"
  }
}

terraform {
  backend "kubernetes" {
    secret_suffix  = "{{ component.name }}"
    config_path    = "~/.kube/config"
    config_context = "{{ kubeinstaller.context }}"
    namespace      = "{{ component.namespace }}"
  }
}

{%- for controller in kubeinstaller.sys.ingress.controllers %}


resource "helm_release" "{{ controller.name }}-ingress" {
  name       = "{{ controller.name }}-ingress"
  repository = "https://kubernetes.github.io/ingress-nginx"
  namespace  = "{{ kubeinstaller.sys.ingress.namespace }}"
  chart      = "ingress-nginx"
  version    = "4.6.1"

  set {
    name  = "nameOverride"
    value = "{{ controller.name }}-ingress"
  }

  set {
    name  = "fullnameOverride"
    value = "{{ controller.name }}-ingress"
  }

  set {
    name  = "controller.affinity.podAntiAffinity.requiredDuringSchedulingIgnoredDuringExecution[0].topologyKey"
    value = "kubernetes.io/hostname"
  }

  set {
    name  = "controller.affinity.nodeAffinity.preferredDuringSchedulingIgnoredDuringExecution[0].weight"
    value = "1"
  }

  set {
    name  = "controller.affinity.nodeAffinity.preferredDuringSchedulingIgnoredDuringExecution[0].preference.matchExpressions[0].key"
    value = "node-role.kubernetes.io/load-balancer"
  }

  set {
    name  = "controller.affinity.nodeAffinity.preferredDuringSchedulingIgnoredDuringExecution[0].preference.matchExpressions[0].operator"
    value = "Exists"
  }

  set {
    name  = "controller.config.ssl-ciphers"
    value = {{ (kubeinstaller.sys.ingress.controllerProfiles | selectattr('name', '==', controller.profile) | map(attribute='sslCiphers') | first | default('')) | to_json }}
  }

  set {
    name  = "controller.config.log-format-upstream"
    value = {{ (kubeinstaller.sys.ingress.controllerProfiles | selectattr('name', '==', controller.profile) | map(attribute='logFormatUpstream') | first | default('')) | to_json }}
  }

  set {
    name  = "controller.config.log-format-escape-json"
    value = {{ (kubeinstaller.sys.ingress.controllerProfiles | selectattr('name', '==', controller.profile) | map(attribute='logFormatUpstream') | first | default('')) | to_json }}
  }

  set {
    name  = "controller.extraEnvs[0].name"
    value = "TZ"
  }

  set {
    name  = "controller.extraEnvs[0].value"
    value = {{ kubeinstaller.sys.ingress.controllerProfiles | selectattr('name', '==', controller.profile) | map(attribute='tz') | first | to_json }}
  }

  set {
    name  = "controller.electionID"
    value = "{{ controller.name }}"
  }

  set {
    name  = "controller.ingressClass"
    value = ""
  }

  set {
    name  = "controller.ingressClassResource.enabled"
    value = "false"
  }

  set {
    name  = "controller.ingressClassResource.controllerValue"
    value = "k8s.io/{{ controller.name }}"
  }

  set {
    name  = "controller.replicaCount"
    value = "2"
  }

  set {
    name  = "controller.service.annotations.metallb\\.universe\\.tf/address-pool"
    value = "{{ controller.network.poolName }}"
  }

  set {
    name  = "controller.service.annotations.metallb\\.universe\\.tf/allow-shared-ip"
    value = "{{ controller.network.poolName }}"
  }

  set {
    name  = "controller.service.enableHttps"
    value = "true"
  }

  set {
    name  = "controller.tolerations[0].key"
    value = "node-role.kubernetes.io/load-balancer"
  }

  set {
    name  = "controller.tolerations[0].operator"
    value = "Exists"
  }

  set {
    name  = "controller.tolerations[0].effect"
    value = "NoSchedule"
  }
}
{%- endfor %}
